searchNodes=[{"doc":"Orion is a Dynamic Distributed Profiler. It allows you to profile any function in a beam cluster and get back an histogram representing the profile of the function calls across the whole cluster. Live, with low overhead, making it suitable to run in production. It uses Erlang dynamic tracing under the hood. It is meant to be used as a library in part of your existing application. If you run your application non clustered, you will be able to trace the node you connect to. If your applications are connected via Distributed Erlang, then you will get a histogram of every call on every node, aggregated. Non Goals Be useable in any BEAM language. This may happen in the future but for now we depend on dog_sketch which is in elixir Making it easy to run the UI locally and connect remotely to a cluster. This may come in the future or in a paid extension. If you are interested, contact me on the Elixir Forum . In the meantime, you can use the mix dev local development setup as a starting point to do your own. Orion totally work remotely connected with erlang distribution, so as long as you can connect to your cluster (and deactivate the :self_profile option in your endpont), it should just work. Session handling, in particular personal auth, and more. This may come in the future or in a paid extension. If you are interested, contact me on the Elixir Forum . Refreshes clean up the UI. Installation To start using Orion, you will need three steps: Add the orion dependency Configure LiveView Add UI access 1. Add the orion dependency Add the following to your mix.exs and run mix deps.get : def deps do [ { :orion , &quot;~&gt; 1.0&quot; } ] end 2. Configure LiveView The Orion UI is built on top of LiveView. If LiveView is already installed in your app, feel free to skip this section. If you plan to use LiveView in your application in the future, we recommend you to follow the official installation instructions . This guide only covers the minimum steps necessary for the Orion UI itself to run. First, update your endpoint's configuration to include a signing salt. You can generate a signing salt by running mix phx.gen.secret 32 (note Phoenix v1.5+ apps already have this configuration): # config/config.exs config :my_app , MyAppWeb.Endpoint , live_view : [ signing_salt : &quot;SECRET_SALT&quot; ] Then add the Phoenix.LiveView.Socket declaration to your endpoint: socket &quot;/live&quot; , Phoenix.LiveView.Socket And you are good to go! 3. Add Orion UI access for development-only usage Once installed, update your router's configuration to forward requests to an OrionWeb with a unique name of your choosing: # lib/my_app_web/router.ex use MyAppWeb , :router import OrionWeb.Router ... if Mix . env ( ) == :dev do scope &quot;/&quot; do pipe_through [ :browser ] live_orion &quot;/orion&quot; end end This is all. Run mix phx.server and access the &quot;/orion&quot; to start profiling. Extra: Add Orion access on all environments (including production) If you want to use the Orion UI in production, you should put it behind some authentication and allow only admins to access it. If you have an authentication layer already for admins, live_orion accept an :on_mount option, to specify the hooks to validate your authentication, as described in the official phoenix guide about security If your application does not have an admins-only section yet, you can use Plug.BasicAuth to set up some basic authentication as long as you are also using SSL (which you should anyway): # lib/my_app_web/router.ex use MyAppWeb , :router import OrionWeb.Router ... pipeline :admins_only do plug :admin_basic_auth end scope &quot;/&quot; do pipe_through [ :browser , :admins_only ] live_orion &quot;/orion&quot; end defp admin_basic_auth ( conn , _opts ) do username = System . fetch_env! ( &quot;AUTH_USERNAME&quot; ) password = System . fetch_env! ( &quot;AUTH_PASSWORD&quot; ) Plug.BasicAuth . basic_auth ( conn , username : username , password : password ) end If you are running your application behind a proxy or a webserver, you also have to make sure they are configured for allowing WebSocket upgrades. For example, here is an article on how to configure Nginx with Phoenix and WebSockets. Finally, you will also want to configure your config/prod.exs and use your domain name under the check_origin configuration: check_origin : [ &quot;//myapp.com&quot; ] Then you should be good to go!","ref":"Orion.html","title":"Orion","type":"module"},{"doc":"","ref":"Orion.MatchSpec.html","title":"Orion.MatchSpec","type":"module"},{"doc":"","ref":"Orion.MatchSpec.html#from_phxlv_session/1","title":"Orion.MatchSpec.from_phxlv_session/1","type":"function"},{"doc":"","ref":"Orion.MatchSpec.html#mfa/1","title":"Orion.MatchSpec.mfa/1","type":"function"},{"doc":"","ref":"Orion.MatchSpec.html#to_phxlv_session/1","title":"Orion.MatchSpec.to_phxlv_session/1","type":"function"},{"doc":"","ref":"Orion.MatchSpec.html#t:t/0","title":"Orion.MatchSpec.t/0","type":"type"},{"doc":"","ref":"Orion.MatchSpecStore.html","title":"Orion.MatchSpecStore","type":"module"},{"doc":"","ref":"Orion.MatchSpecStore.html#from_phxlv_to_ms_options/1","title":"Orion.MatchSpecStore.from_phxlv_to_ms_options/1","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#get/1","title":"Orion.MatchSpecStore.get/1","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#ms_options_to_phxlv_session/1","title":"Orion.MatchSpecStore.ms_options_to_phxlv_session/1","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#new/3","title":"Orion.MatchSpecStore.new/3","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#string_to_boolean/1","title":"Orion.MatchSpecStore.string_to_boolean/1","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#string_to_state/1","title":"Orion.MatchSpecStore.string_to_state/1","type":"function"},{"doc":"","ref":"Orion.MatchSpecStore.html#t:key/0","title":"Orion.MatchSpecStore.key/0","type":"type"},{"doc":"","ref":"Orion.MatchSpecStore.html#t:ms_options/0","title":"Orion.MatchSpecStore.ms_options/0","type":"type"},{"doc":"","ref":"Orion.MatchSpecStore.html#t:session/0","title":"Orion.MatchSpecStore.session/0","type":"type"},{"doc":"A Registry based pubsub that works per session. Allows all the LV of a session to talk together.","ref":"Orion.SessionPubsub.html","title":"Orion.SessionPubsub","type":"module"},{"doc":"","ref":"Orion.SessionPubsub.html#dispatch/2","title":"Orion.SessionPubsub.dispatch/2","type":"function"},{"doc":"","ref":"Orion.SessionPubsub.html#register/2","title":"Orion.SessionPubsub.register/2","type":"function"},{"doc":"","ref":"OrionWeb.Components.html","title":"OrionWeb.Components","type":"module"},{"doc":"Generates a generic error message. Slots inner_block (required)","ref":"OrionWeb.Components.html#error/1","title":"OrionWeb.Components.error/1","type":"function"},{"doc":"Renders an input with label and error messages. A %Phoenix.HTML.Form{} and field name may be passed to the input to build input names and error messages, or all the attributes and errors may be passed explicitly. Examples &lt; . input field = { @form [ :email ] } type = &quot;email&quot; / &gt; &lt; . input name = &quot;my-input&quot; errors = { [ &quot;oh no!&quot; ] } / &gt; Attributes id ( :any ) - Defaults to nil . name ( :any ) label ( :string ) - Defaults to nil . value ( :any ) type ( :string ) - Defaults to &quot;text&quot; . field ( Phoenix.HTML.FormField ) - a form field struct retrieved from the form, for example: @form[:email]. errors ( :list ) - Defaults to [] . checked ( :boolean ) - the checked flag for checkbox inputs. prompt ( :string ) - the prompt for select inputs. Defaults to nil . options ( :list ) - the options to pass to Phoenix.HTML.Form.options_for_select/2. multiple ( :boolean ) - the multiple flag for select inputs. Defaults to false . Global attributes are accepted. Slots inner_block","ref":"OrionWeb.Components.html#input/1","title":"OrionWeb.Components.input/1","type":"function"},{"doc":"Renders a label. Attributes for ( :string ) - Defaults to nil . Slots inner_block (required)","ref":"OrionWeb.Components.html#label/1","title":"OrionWeb.Components.label/1","type":"function"},{"doc":"","ref":"OrionWeb.Components.html#translate_error/1","title":"OrionWeb.Components.translate_error/1","type":"function"},{"doc":"Translates the errors for a field from a keyword list of errors.","ref":"OrionWeb.Components.html#translate_errors/2","title":"OrionWeb.Components.translate_errors/2","type":"function"},{"doc":"This is the central LiveView for the Orion UI. It handles the form to pass a matchspec, store then in the Orion.MatchSpecDB, then start the chart as needed by passing the ref to that line to the chart liveview in the sessions. It also handles pause/start TODO: change this, to allow multiple users at once","ref":"OrionWeb.PageLive.html","title":"OrionWeb.PageLive","type":"module"},{"doc":"","ref":"OrionWeb.PageLive.html#pause_state_text/1","title":"OrionWeb.PageLive.pause_state_text/1","type":"function"},{"doc":"Provides LiveView routing for Orion.","ref":"OrionWeb.Router.html","title":"OrionWeb.Router","type":"module"},{"doc":"Define an Orion route. It expects the path Orion will be mounted at and a set of options All the Orion Pages will be under a live_session. ## Options :live_socket_path - Configures the socket path. it must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint. :csp_nonce_assign_key - an assign key to find the CSP nonce value used for assets. Supports either atom() or a map of type %{optional(:img) =&gt; atom(), optional(:script) =&gt; atom(), optional(:style) =&gt; atom()} :on_mount - Pass a list of on_mount hooks to live_session, like if you want to validate authentication with :on_mount . See the phoenix_liveview docs :live - Configure options to inject into the Orion route :self_profile - Configure if the tracing is applied to the node running Orion itself, default to true :fake_data - Configure if the tracing form allow you to run with fake data, default to false Examples defmodule MyAppWeb.Router do use Phoenix.Router import OrionWeb.Router scope &quot;/&quot; , MyAppWeb do pipe_through [ :browser ] live_orion &quot;/orion&quot; , on_mount : { MyAppWeb.SomeHook , :admin } end end","ref":"OrionWeb.Router.html#live_orion/2","title":"OrionWeb.Router.live_orion/2","type":"macro"}]